package it.amattioli.guidate.browsing.calendar;

import java.text.SimpleDateFormat;
import java.util.Properties;

import it.amattioli.encapsulate.browsers.CalendarBrowser;

import org.apache.commons.lang.StringUtils;
import org.zkoss.zul.Label;
import org.zkoss.zul.Row;
import org.zkoss.zul.RowRenderer;
import org.zkoss.zul.Vbox;

public class CalendarGridRenderer implements RowRenderer {
	private Properties names = new Properties();
	
	public CalendarGridRenderer() throws Exception {
		names.load(this.getClass().getResourceAsStream("names.properties"));
	}
	
	@Override
	public void render(Row row, Object val) throws Exception {
		CalendarBrowser<?, ?> brw = (CalendarBrowser<?, ?>)val;
		if (brw.getLimits() != null && !StringUtils.isBlank(names.getProperty(brw.getLimits().getClass().getCanonicalName()+".row"))) {
			String format = names.getProperty(brw.getLimits().getClass().getCanonicalName()+".row");
			String cellName = new SimpleDateFormat(format).format(brw.getLimits().getLow());
			Label label = new Label(cellName);
			label.setParent(row);
		}
		addCell(row, brw);
		while(brw.hasNextInterval()) {
			brw.nextInterval();
			addCell(row, brw);
		}
	}
	
	private void addCell(Row row, CalendarBrowser<?, ?> brw) {
		Vbox cell = new Vbox();
		if (!StringUtils.isBlank(names.getProperty(brw.getInterval().getClass().getCanonicalName()+".cell"))) {
			String format = names.getProperty(brw.getInterval().getClass().getCanonicalName()+".cell");
			String cellName = new SimpleDateFormat(format).format(brw.getInterval().getInitTime());
			Label label = new Label(cellName);
			label.setParent(cell);
		}
		cell.setParent(row);
	}

}
