package it.amattioli.guidate.browsing.calendar;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.util.ArrayList;
import java.util.List;

import it.amattioli.applicate.properties.ValuesListerImpl;
import it.amattioli.encapsulate.browsers.CalendarBrowser;

import org.zkoss.zul.AbstractListModel;
import org.zkoss.zul.event.ListDataEvent;

public class CalendarModel extends AbstractListModel {
	private CalendarBrowser<?, ?> browser;
	private List<?> currContent;
	private PropertyChangeListener intervalChangeListener;
	
	public CalendarModel(CalendarBrowser<?, ?> browserParam) {
		this.browser = browserParam;
		intervalChangeListener = new PropertyChangeListener() {
		    
			@Override
			public void propertyChange(PropertyChangeEvent evt) {
				if ("interval".equals(evt.getPropertyName())) {
					currContent = null;
					fireEvent(ListDataEvent.CONTENTS_CHANGED, -1, -1);
				}
			}
        	
        };
		this.browser.addPropertyChangeListener(intervalChangeListener);
	}
	
	@Override
	public Object getElementAt(int idx) {
		return getModelValues().get(idx);
	}

	@Override
	public int getSize() {
		return getModelValues().size();
	}
	
	private List<?> getModelValues() {
		if (currContent == null) {
			CalendarBrowser<?, ?> sbrw = browser.subBrowser();
			List<Object> result = new ArrayList<Object>();
			result.add(sbrw.subBrowser());
			while(sbrw.hasNextInterval()) {
				sbrw.nextInterval();
				result.add(sbrw.subBrowser());
			}
			currContent = result;
		}
		return currContent;
	}

}
