package it.amattioli.guidate.init;

import it.amattioli.authorizate.sessions.DefaultAuthorizationSession;
import it.amattioli.authorizate.users.User;
import it.amattioli.dominate.RepositoryRegistry;
import it.amattioli.guidate.config.GuidateConfig;

import org.zkoss.zk.ui.WebApp;
import org.zkoss.zk.ui.util.WebAppCleanup;
import org.zkoss.zk.ui.util.WebAppInit;

public class ApplicationInit implements WebAppInit, WebAppCleanup {

	@Override
	public void init(WebApp app) throws Exception {
		RepositoryRegistry.instance().setRepositoryFactoryClass(GuidateConfig.instance.getRepositoryFactoryClass());
		Class<? extends User> userClass = GuidateConfig.instance.getUserClass();
		if (userClass != null) {
			DefaultAuthorizationSession.setUserClass(userClass);
		}
	}

	@Override
	public void cleanup(WebApp app) throws Exception {
		// TODO Auto-generated method stub
		
	}

}
