package it.amattioli.guidate.properties;

import it.amattioli.applicate.properties.PropertyAvailabilityRetriever;
import it.amattioli.applicate.properties.PropertyAvailabilityRetrieverImpl;
import it.amattioli.guidate.properties.PropertyComposer;

import org.zkoss.zk.ui.Component;
import org.zkoss.zkplus.databind.TypeConverter;

public class AvailableComposer extends PropertyComposer {

	public AvailableComposer() {
		
	}
	
	@Override
	protected Object getPropertyValue(Component comp) throws Exception {
		Object backBean = getBackBean(comp);
		PropertyAvailabilityRetriever retriever = new PropertyAvailabilityRetrieverImpl(backBean);
		return retriever.isPropertyAvailable(super.getPropertyName());
	}

	@Override
	public String getPropertyName() {
		return PropertyAvailabilityRetrieverImpl.availableProperty(super.getPropertyName());
	}

	@Override
	protected String getComponentValueAttribute() {
		return "visible";
	}
	
	protected TypeConverter getConverter(Component comp) {
		return new WritableConverter();
	}
	
	private static class WritableConverter implements TypeConverter {

		@Override
		public Object coerceToBean(Object val, Component comp) {
			return val;
		}

		@Override
		public Object coerceToUi(Object val, Component comp) {
			return val == null ? true : !(Boolean)val;
		}

	}
}
